﻿local function msg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg)
end

local mm = {}
local playerarrived = false
local numranks = nil
local ranknames = {}
local guildranks = {}
local numfriends = 0
local friends = {}

local function getguildranks()
	if IsInGuild() then
		GuildRoster()
		guildranks = {}
		numranks = GuildControlGetNumRanks()
		for i=1,numranks do
			guildranks[i] = GuildControlGetRankName(i)
		end
		return guildranks
	end
	return false
end

local function getfriends()
	numfriends = GetNumFriends()
	for i=1,numfriends do
		friends[i] = GetFriendInfo(i)
	end
	if numfriends > 0 then
		return friends
	end
	return false
end

makemods = LibStub("AceAddon-3.0"):NewAddon("MakeMods")
local L = LibStub("AceLocale-3.0"):GetLocale("MakeMods", true)

function options()
	local options = {
		name = "MakeMods",
		handler = makemods,
		type = "group",
		childGroups = "tab",
		args = {
			header = {
				order = 1,
				type = "description",
				name = L["Notes"],
				image = "Interface\\Icons\\achievement_dungeon_gloryoftheraider",
				imageWidth = 32,
				imageHeight = 32,
			},
			extralinebreak = {
				order = 2,
				type = "description",
				name = "\n",
			},
			byguildrankoptionsgroup = {
				order = 10,
				type = "group",
				name = "Gildenränge",
				args = {
					byguildrank = {
						order = 10,
						type = "multiselect",
						name = L["PromoteGuildRanks"],
						desc = L["PromoteGuildRanksDescInG"] .. "\n\n" .. L["PromoteGuildRanksDescInGAddendum"],
						values = getguildranks() or function() end,
						get = function() end,
						set = function() end,
					},
				},
			},
			friendsoptionsgroup = {
				order = 20,
				type = "group",
				name = "Freunde",
				args = {
					friends = {
						order = 10,
						type = "multiselect",
						name = L["PromoteFriends"],
						values = getfriends() or function() end,
						get = function() end,
						set = function() end,
					},
				},
			},
			bynameoptionsgroup = {
				order = 30,
				type = "group",
				name = "Spielernamen",
				args = {
					byname = {
						order = 10,
						type = "input",
						multiline = true,
						width = "full",
						name = L["PromoteNames"],
						get = function() end,
						set = function() end,
					},
				},
			},
		},
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MakeMods", options, nil)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MakeMods")
end

function makemods:OnInitialize()
  -- Code that you want to run when the addon is first loaded goes here.
end

function makemods:OnEnable()
    -- Called when the addon is enabled
end

function makemods:OnDisable()
    -- Called when the addon is disabled
end

function makemods_onload(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	self:RegisterEvent("CALENDAR_ACTION_PENDING")
	self:RegisterEvent("ADDON_LOADED")
end

local function kdn()
	local guild = GetGuildInfo("player")
	local faction = UnitFactionGroup("player")
	local realm = GetRealmName()
	if guild == "Kinder der Nacht" and faction == "Horde" and realm == "Das Konsortium" then
		return true
	end
	return false
end

local function makemods()
	if mm then
		local inv = CalendarEventGetNumInvites()
		local invitee, ismod = nil
		for i=1, inv do
			invitee,_,_,_,_,ismod = CalendarEventGetInvite(i)
			for _,v in ipairs(mm) do
				if invitee == v and invitee ~= GetUnitName("player") and CalendarEventCanModerate(i) and ismod ~= "MODERATOR" and ismod ~= "CREATOR" then
					CalendarEventSetModerator(i)
				end
			end
		end
	end
end

function makemods_onevent(self, event, ...)
	if event == "ADDON_LOADED" and ... == "MakeMods" then
		options()
		self:UnregisterEvent("ADDON_LOADED")
	elseif event == "PLAYER_ENTERING_WORLD" then
		playerarrived = true
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	elseif event == "GUILD_ROSTER_UPDATE" then
		msg(event)
		if playerarrived then
			mm = {}
			local num = GetNumGuildMembers(1)
			if num > 0 then
				for i = 1, num do
					local rostername, rosterrank, rosterrankindex = GetGuildRosterInfo(i)
					if rostername and rosterrankindex <= 3 then
						table.insert(mm, rostername)
					end
				end
			end
			if IsInGuild() then
				numranks = GuildControlGetNumRanks()
				ranknames = {}
				for i=1,numranks do
					ranknames[i] = GuildControlGetRankName(i)
				end
			end
		else
			GuildRoster()
		end
	elseif event == "CALENDAR_ACTION_PENDING" then
		if kdn() then
			makemods()
		end
	end
end